<?php

/**
 * Creado - 20200313
 * migra_cre actions.
 *
 * @package    cartera
 * @subpackage migra_cre
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class migra_creActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_MIGRA_CRE_V',
        'CA_CREDITO',
        'INTERCEROS',
        'TS_TD'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CA_CREDITO' =>
        array(
            'id_credito' => 'CA_MIGRA_CRE_V'
        ),
        'INTERCEROS' =>
        array(
            'id_mae_ter' => 'CA_CREDITO'
        ),
        'TS_TD,LEFT' =>
        array(
            'id_ts_td-id' => 'CA_MIGRA_CRE_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_MIGRA_CRE_V' =>
        array(
            'id_credito' => 'id_credito',
            'vradicion' => 'vradicion',
            'vradicion_orig' => 'vradicion_orig',
            'id_ts_td' => 'id_ts_td',
            'doc_soporte' => 'doc_soporte',
            'fecha_doc' => 'fecha_doc',
            'observaciones' => 'observaciones',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'migracion_sgc' => 'migracion_sgc'
        ),
        'CA_CREDITO' =>
        array(
            'id_anhos' => 'id_anhos',
            'id_punto_venta' => 'id_punto_venta',
            'id_tipo_credito' => 'id_tipo_credito',
            'sec_credito' => 'sec_credito',
            'id_con_credito' => 'id_con_credito',
            'fecha_proceso' => 'fecha_proceso',
            'id_bn' => 'id_bn',
            'id_cb' => 'id_cb',
            'oficina' => 'oficina',
            'valor' => 'valor',
            'estado' => 'estado',
            'fecha_anu' => 'fecha_anu',
            'motivo_anu' => 'motivo_anu',
            'fecha' => 'fecha',
            'usuariolog' => 'usuariolog',
            'id_mae_ter' => 'id_mae_ter'
        ),
        'INTERCEROS' =>
        array(
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc',
            'num_doc,||, - ,||,razon_soc' => 'tercero'
        ),
        'TS_TD' =>
        array(
            'documento' => 'documento',
            'descripcion' => 'descripcion_td'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_MIGRA_CRE_V' => array(
            'id_credito,a' => array('!=' => array(-1)),
            'id_credito,b' => array('=' => array('id_credito')),
            'vradicion_orig,a' => array('>=' => array('valor_ini')),
            'vradicion_orig,b' => array('<=' => array('valor_fin')),
            'vradicion_orig,c' => array('=' => array('valor_exacto')),
            'migracion_sgc' => array('=' => array('migracion_sgc')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CA_CREDITO' => array(
            'id_anhos' => array('=' => array('id_anhos')),
//            'id_punto_venta' => array('=' => array('id_punto_venta')),
            'id_tipo_credito' => array('=' => array('id_tipo_credito')),
            'sec_credito' => array('LIKE' => array('sec_credito')),
            'id_con_credito' => array('=' => array('id_con_credito')),
            'id_bn' => array('=' => array('id_bn')),
            'id_cb' => array('=' => array('id_cb')),
            'id_ts_td' => array('=' => array('id_ts_td')),
            'id_mae_ter' => array('=' => array('id_mae_ter'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $fields_orderBy = array(
        'fecha_proceso', 'sec_credito', 'id_con_credito', 'id_tipo_credito'
    ); //campos para el ordenamiento de la consulta
    protected $table_field_obligatory = array(
    ); //campos obligatorios de filtro - estan en el request

    /**
     * 
     * @param sfWebRequest $request
     */

    public function executeUpdate(sfWebRequest $request) {


        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */

        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        try {


            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            //variables obligatorias
            $id_credito = $request['id_credito'];
            $id_ts_td = $request['id_ts_td'];
            $doc_soporte = $request['doc_soporte'];
            $fecha_doc = $request['fecha_doc'];
            $observaciones = $request['observaciones'];
            $usuario_log = $request['username'];


            $sql = <<<EOD
update ca_migra_cre 
set vradicion = 0, 
id_ts_td = '$id_ts_td', 
doc_soporte = '$doc_soporte', 
fecha_doc = to_date('$fecha_doc','YYYY-MM-DD'), 
observaciones = '$observaciones', 
fecha_log = TRUNC(SYSDATE), 
usuario_log = '$usuario_log'
where id_credito = $id_credito  
EOD;

            $this->conn->execute($sql);
            $mensaje = "Se edito correctamente ";

            //Genera el excedente en cartera
            $sql = <<<EOD
insert into ca_excedentes
select
null as id_excedente,
id_credito as id_credito,
vradicion_orig as valor,
0 as en_uso,
null as id_credito_aplicado,
null as id_nov_devol_exced,
null as id_mae_ter
from ca_migra_cre
where
id_credito = $id_credito
and id_credito not in (select id_credito from ca_excedentes where id_credito = $id_credito)  
EOD;

            $this->conn->execute($sql);
            
            $this->conn->commit();
            $this->list_data = array();
            $this->status = 0;
            $this->mensajeError = $mensaje;
        } catch (Exception $e) {

            $mensaje = "No se puede editar";
            $this->conn->rollback();
            $this->status = 1;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
            $this->logMessage($mensaje);
            $this->logMessage($e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
